package com.s_cradle.lifeapp;

import com.nttdocomo.ui.Graphics;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: Sophia Cradle, Inc.</p>
 * @author YOSHIMURA Masaru
 * @version $Id$
 */

public class LifeGame {
  public static final int CELL_WIDTH = 4;
  public static final int CELL_HEIGHT = 4;
  private static final int MATRIX_WIDTH = 50;
  private static final int MATRIX_HEIGHT = 50;

  private int width = MATRIX_WIDTH;
  private int height = MATRIX_HEIGHT;
  private boolean[][][] matrix = new boolean[2][width+2][height+2];
  private int current = 0;

  public LifeGame() {
    //zuݒD
    matrix[0][20][26] = true;
    matrix[0][21][26] = true;
    matrix[0][21][27] = true;
    matrix[0][25][27] = true;
    matrix[0][26][25] = true;
    matrix[0][26][27] = true;
    matrix[0][27][27] = true;
  }

  public boolean[][] getMatrix(){
    return matrix[current];
  }

  public int getWidth(){
    return width;
  }

  public int getHeight(){
    return height;
  }

  /**
   * zuՖʂ̑傫ZbgD
   */
  public void setSize(int width_, int height_){
    boolean[][] m = new boolean[width_+2][height_+2];
    int minw = (width < width_) ? width : width_;
    int minh = (height < height_) ? height : height_;
    width = width_;
    height = height_;

    for(int i=0;i<minw;i++){
      for(int j=0;j<minh;j++){
        m[i][j] = matrix[current][i][j];
      }
    }
    matrix[current] = m;
    matrix[(current == 0) ? 1 : 0] = new boolean[width+2][height+2];
  }

  /**
   * CtQ[̃[͎̂Ƃ
   * ĂZɑ΂āCɐĂZ2C3̏ꍇ͐D
   * ȊO͎ʁD
   * łZɑ΂āCɐĂZ3̏ꍇ͐D
   * ȊO͎ʁD
   */
  public synchronized void next(){
    int next = (current == 0) ? 1 : 0;
    int life;

    for(int i=1;i<width+1;i++){
      for(int j=1;j<height+1;j++){
        matrix[next][i][j] = false;
        life = 0;
        for(int a=i-1;a<=i+1;a++){
          for (int b = j - 1; b <= j + 1; b++) {
            if(a == i && b == j){
              continue;
            }
            if (matrix[current][a][b]) {
              life++;
            }
          }
        }
        if(matrix[current][i][j]){
          if(1 < life && life <= 3){
            matrix[next][i][j] = true;
          }
        } else{
          if(life == 3){
            matrix[next][i][j] = true;
          }
        }
      }
    }
    current = next;
  }

  /**
   * ՖʂZbgDՖʂ̑傫͈̂̂ƍ킹D
   */
  public synchronized void setMatrix(boolean[][] copy){
    matrix[current] = copy;
    width = copy.length-2;
    height = copy[0].length-2;
    matrix[(current == 0) ? 1 : 0] = new boolean[width+2][height+2];
  }

  /**
   * ݂̔Ֆʂ̕`
   */
  public synchronized void paint(Graphics g) {
    //݂̔ՖʂmƂD
    boolean[][] m = matrix[current];

    //Ֆʂ̊Og`D
    g.setColor(g.getColorOfName(g.RED));
    g.drawRect(CELL_WIDTH-1,CELL_HEIGHT-1,width*CELL_WIDTH,height*CELL_HEIGHT);

    //`FFɐݒD
    g.setColor(g.getColorOfName(g.BLUE));

    for(int i=1;i<width+1;i++){
      for(int j=1;j<height+1;j++){
        //ĂZ̏ꏊɑ΂Ă̂݁Clp`D
        if(m[i][j]){
          g.fillRect(i * CELL_WIDTH, j * CELL_HEIGHT, CELL_WIDTH-1, CELL_HEIGHT-1);
        }
      }
    }
  }
}
