package com.s_cradle.lifeapp;

import java.io.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: Sophia Cradle, Inc.</p>
 *
 * @author YOSHIMURA Masaru
 * @version $Id$
 */
public class LifeGameData {
  private String name;
  private boolean[][] matrix;

  public LifeGameData(String name_, boolean[][] matrix_){
    name = name_;
    matrix = matrix_;
  }

  public LifeGameData(DataInputStream stream) throws IOException{
    name = stream.readUTF();
    int width = stream.readInt();
    int height = stream.readInt();
    matrix = new boolean[width+2][height+2];
    for(int i=1;i<width+1;i++){
      for(int j=1;j<height+1;j++){
        matrix[i][j] = stream.readBoolean();
      }
    }
  }

  public String getName(){
    return name;
  }

  public boolean[][] getMatrix(){
    return matrix;
  }

  public void setName(String name_){
    name = name_;
  }

  public void write(DataOutputStream dos) throws IOException{
    dos.writeUTF(name);
    dos.writeInt(matrix.length-2);
    dos.writeInt(matrix[0].length-2);
    for(int i=1;i<matrix.length-1;i++){
      for(int j=1;j<matrix[0].length-1;j++){
        dos.writeBoolean(matrix[i][j]);
      }
    }
  }
}
